/*
 * last-word/last.c --
 *
 * This program creates a dangling pointer to the heap.
 */

#define _POSIX_C_SOURCE 200809L

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

static char* last_word(char *msg)
{
    char *last = NULL, *next;
    char *s = strdup(msg);
    if (s) {
        last = strtok(s, " ");
        while ((next = strtok(NULL, " ")) != NULL) {
            last = next;
        }
        free(s);
    }
    return last;
}

int main(int argc, char *argv[])
{
    for (int i = 1; i < argc; i++) {
        char *p = last_word(argv[i]);
        if (p) {
            puts(p);
        }
    }
    return 0;
}
